<?php

/**
 * @file
 * User Management Plus admin pages.
 */

/**
 * UMP Rules Overview callback function.
 */
function ump_rules_overview() {
  $return = "";

  $table["header"] = array(
    t("Role"),
    t("Allow to create"),
    t("Allow to view"),
    t("Allow to edit"),
    t("Allow to delete"),
    t("Operations"),
  );
  $table["rows"] = array();
  $table["attributes"] = array();
  $table["caption"] = "";
  $table["colgroups"] = array();
  $table["sticky"] = TRUE;
  $table["empty"] = t("No rules created yet.");

  // Get the users roles defined and the custom user fields defined.
  $get_roles = ump_get_user_roles();
  $user_fields = ump_get_user_user_fields();

  // Get the rules defined.
  $rules = ump_get_ump_crud_rules_all();
  if (is_array($rules)) {
    foreach ($rules as $rule_key) {
      $rule = variable_get($rule_key);

      $allow_to_create = "";
      if ($rule["allow_to_create_enable"] == 1) {
        $allow_to_create .= "<b>" . $get_roles[$rule["allow_to_create_role"]] . "</b> ";
        if ($rule["allow_to_create_overtake"] == 1) {
          $allow_to_create .= t("and take over the field") . " <b>" . $user_fields[$rule["allow_to_create_overtake_field"]] . "</b>";
        }
      }
      $allow_to_view = "";
      if ($rule["allow_to_view_enable"] == 1) {
        $allow_to_view .= "<b>" . $get_roles[$rule["allow_to_view_role"]] . "</b> ";
        $allow_to_view .= t("which") . " <b>" . $rule["allow_to_view_which"] . "</b>";
        if ($rule["allow_to_view_which"] == "if_share_common_field") {
          $allow_to_view .= " " . t("field") . " <b>" . $user_fields[$rule["allow_to_view_common_field"]] . "</b>";
        }
      }
      $allow_to_edit = "";
      if ($rule["allow_to_edit_enable"] == 1) {
        $allow_to_edit .= "<b>" . $get_roles[$rule["allow_to_edit_role"]] . "</b> ";
        $allow_to_edit .= t("which") . " <b>" . $rule["allow_to_edit_which"] . "</b>";
        if ($rule["allow_to_edit_which"] == "if_share_common_field") {
          $allow_to_edit .= " " . t("field") . " <b>" . $user_fields[$rule["allow_to_edit_common_field"]] . "</b>";
        }
      }
      $allow_to_delete = "";
      if ($rule["allow_to_delete_enable"] == 1) {
        $allow_to_delete .= "<b>" . $get_roles[$rule["allow_to_delete_role"]] . "</b> ";
        $allow_to_delete .= t("which") . " <b>" . $rule["allow_to_delete_which"] . "</b>";
        if ($rule["allow_to_delete_which"] == "if_share_common_field") {
          $allow_to_delete .= " " . t("field") . " <b>" . $user_fields[$rule["allow_to_delete_common_field"]] . "</b>";
        }
      }

      $row = array(
        "<b>" . $get_roles[$rule["select_role"]] . "</b>",
        $allow_to_create,
        $allow_to_view,
        $allow_to_edit,
        $allow_to_delete,
        l(t('Edit'), 'admin/config/ump/rule/edit/' . $rule_key) . " " . l(t('Delete'), 'admin/config/ump/rule/delete/' . $rule_key),
      );
      array_push($table["rows"], $row);
    }
  }

  $return .= theme_table($table);
  $return .= l(t('Create Rule'), 'admin/config/ump/rule/create');

  return $return;
}
