<?php

/**
 * @file
 * User Management Plus user overview pages.
 */

/**
 * UMP overview page callback.
 */
function ump_user_page() {
  $return = "";

  $table["header"] = array(
    "Name",
    "Roles",
    "Operations",
  );
  $table["rows"] = array();
  $table["attributes"] = array();
  $table["caption"] = "";
  $table["colgroups"] = array();
  $table["sticky"] = TRUE;
  $table["empty"] = t("No users found");

  $rules = ump_get_ump_crud_rules_all();
  foreach ($rules as $rule_key) {
    $rule = variable_get($rule_key);
    if ($rule["allow_to_view_enable"] == 1) {
      // Get the users that we are allowed to display.
      $query = 'SELECT ur.uid
        FROM {users_roles} AS ur
        WHERE ur.rid = :rid';
      $result = db_query($query, array(':rid' => $rule["allow_to_view_role"]));
      $uids = $result->fetchCol();
      $users = user_load_multiple($uids);
      foreach ($users as $load_user) {
        // Check the view permission.
        if (drupal_valid_path('user/' . $load_user->uid)) {
          $roles = "";
          $edit = "";
          $delete = "";
          // Check the edit permission.
          if (drupal_valid_path('user/' . $load_user->uid . '/edit')) {
            $edit = l(t('Edit'), 'user/' . $load_user->uid . '/edit');
          }
          // Check the delete permission.
          if (drupal_valid_path('user/' . $load_user->uid . '/delete')) {
            $delete = l(t('Delete'), 'user/' . $load_user->uid . '/delete');
          }

          foreach ($load_user->roles as $load_user_key => $load_user_value) {
            $roles .= $load_user_value . "<br>";
          }

          $row = array(
            $load_user->name,
            $roles,
            $edit . " " . $delete,
          );
          array_push($table["rows"], $row);
        }
      }
    }
  }

  $return .= theme_table($table);
  if (ump_check_permission("create")) {
    $return .= l(t('Create User'), 'admin/people/create');
  }

  return $return;
}
